<template>
  <div>
    <a-layout class="user-layout-container">
      <a-layout-content>
        <div class="session-header">
          <div class="top">
            <div class="header">
              <img src="/logo_blue.svg?v2" class="logo" alt="logo">
            </div>
            <h1>SuperEHR | Cập nhật mật khẩu</h1>
          </div>
        </div>
        <div class="user-layout-login-wraper">
          <a-alert
            v-if="erroMessage"
            :message="erroMessage"
            type="error"
            show-icon
            style="margin-bottom: 24px;"
          />

          <a-alert
            v-if="showSuccess"
            style="margin-bottom: 24px;"
            message="Mật khẩu mới đã được cập nhật"
            type="info"
            show-icon
            closable
          />

          <a-spin :spinning="state.loginBtn">
            <a-form :form="form" class="user-layout-login">
              <a-form-item label="Mật khẩu mới">
                <a-input
                  v-decorator="['password', {rules: [{ required: true, message: 'Vui lòng nhập mật khẩu mới'}, { validator: handlePasswordCheck }], validateTrigger: ['change', 'blur']}]"
                  type="password"
                  autocomplete="new-password"
                  placeholder="Mật khẩu mới"
                />
              </a-form-item>
              <a-form-item label="Xác nhận mật khẩu">
                <a-input
                  v-decorator="['password2', {rules: [{ required: true, message: 'Vui lòng xác nhận mật khẩu' }, { validator: handlePassword2Check }], validateTrigger: ['change', 'blur']}]"
                  type="password"
                  autocomplete="false"
                  placeholder="Xác nhận mật khẩu"
                />
              </a-form-item>
              <a-form-item>
                <a-button
                  :loading="state.loginBtn"
                  :disabled="state.loginBtn"
                  @click.stop.prevent="handleSubmit"
                  type="primary"
                  html-type="submit"
                  class="login-button"
                >
                  Cập nhật mật khẩu
                </a-button>
              </a-form-item>
              <a-form-item>
                <span @click="backToLogin" style="float: left;">
                  <a class="forge-password">Quay lại màn hình đăng nhập</a>
                </span>
              </a-form-item>
            </a-form>
          </a-spin>
        </div>
      </a-layout-content>
    </a-layout>
  </div>
</template>

<script>
import { mapActions } from 'vuex'
import { ehrApi } from '@/api'
export default {
  layout: 'SessionLayout',
  data () {
    return {
      erroMessage: null,
      loginBtn: false,
      form: this.$form.createForm(this),
      state: {
        loginBtn: false
      },
      showSuccess: false
    }
  },
  computed: {
    token () {
      const { access_token: token } = this.$route.query
      return token
    }
  },
  methods: {
    ...mapActions('auth', ['login']),
    handlePasswordCheck (rule, value, callback) {
      if (value === undefined) {
        callback(new Error('Vui lòng nhập mật khẩu mới'))
      }
      callback()
    },
    handlePassword2Check (rule, value, callback) {
      const password = this.form.getFieldValue('password')
      if (value === undefined) {
        callback(new Error('Vui lòng nhập lại mật khẩu mới'))
      }
      if (password && value && password.trim() !== value.trim()) {
        callback(new Error('Mật khẩu vừa nhập không trùng khớp. Vui lòng nhập lại.'))
        return
      }
      callback()
    },
    handleSubmit () {
      const {
        form: { validateFields },
        state
      } = this
      state.loginBtn = true
      const validateFieldsKey = ['password', 'password2']
      validateFields(validateFieldsKey, { force: true }, async (err, values) => {
        if (!err) {
          this.erroMessage = null
          try {
            const newPassword = values.password
            await ehrApi.user.changePassword({ newPassword }, this.token)
            this.showSuccess = true
          } catch (error) {
            this.setError(error)
          } finally {
            state.loginBtn = false
          }
        }
      })
    },
    backToLogin () {
      this.$router.push({ path: '/login' })
    },
    setError (err) {
      if (err.errorCode === 'LOGIN_FAILED') {
        this.erroMessage = 'Đăng nhập thất bại, vui lòng kiểm nhập đúng tài khoản và mật khẩu.'
      } else {
        this.erroMessage = 'Đã có lỗi phát sinh'
      }
    }
  }
}
</script>

<style lang="less" scoped>
.user-layout-login-wraper {
  width: 360px;
  margin: auto;
  & > h3 {
    font-size: 16px;
    margin-bottom: 20px;
  }
}
.user-layout-login {
  label {
    font-size: 14px;
  }

  .getCaptcha {
    display: block;
    width: 100%;
    height: 40px;
  }

  .forge-password {
    font-size: 14px;
  }

  button.login-button {
    width: 100%;
  }

  .user-login-other {
    text-align: left;
    margin-top: 24px;
    line-height: 22px;

    .item-icon {
      font-size: 24px;
      color: rgba(0, 0, 0, 0.2);
      margin-left: 16px;
      vertical-align: middle;
      cursor: pointer;
      transition: color 0.3s;

      &:hover {
        color: #1890ff;
      }
    }

    .register {
      float: right;
    }
  }
}
.user-layout-container {
  padding-top: 110px;
  .top {
    text-align: center;

    .header {
      height: 80px;
      line-height: 44px;
      .logo {
        height: 80px;
        vertical-align: top;
        margin-right: 0 !important;
        border-style: none;
      }

      .title {
        font-size: 28px;
        color: rgba(0, 0, 0, 0.85);
        font-family: Avenir, 'Helvetica Neue', Arial, Helvetica, sans-serif;
        font-weight: 600;
        position: relative;
        top: 2px;
      }
    }
    .desc {
      font-size: 14px;
      color: rgba(0, 0, 0, 0.45);
      margin-top: 12px;
      line-height: 20px;
      margin-bottom: 40px;
    }
  }
}
</style>
